REM	HISTORY
REM
REM	2010-06-10	Rev.0	First running/tested Version



@echo off

REM General Settings

set pslog=		pslist.txt
set iplog=		iplist.txt
set svlog=		svlist.txt
set iptimeout=		100
set log=		LightsOut.XP.log
set extendedlog=	on
set wd=			c:\windows\LightsOut.XP

REM In following line you have to define CLients, Programs and Services which will be checked
REM before starting Shutdown Procedure. To avoid delay in Script used units have to be in follow order
REM because Script will leave actual Check if it finds first time '' ''


REM Clients to check

set hostname1=LEVLMBR
set ip1=192.168.1.193
set hostname2=C2-6400
set ip2=192.168.1.103
set hostname3=HP-Notebook
set ip3=192.168.1.102
set hostname4=""
set ip4=""
set hostname5=""
set ip5=""
set hostname6=""
set ip6=""
set hostname7=""
set ip7=""
set hostname8=""
set ip8=""
set hostname9=""
set ip9=""



REM Running Programms to check

set rp1=ntbackup.exe
set rp2=TrueImageHomeService.exe
set rp3=""
set rp4=""
set rp5=""
set rp6=""
set rp7=""
set rp8=""
set rp9=""


REM Services to check

set sv1=""
set sv2=""
set sv3=""



REM *************************************************************
REM *Checking for Client IP-Addresses which shall avoid shutdown*
REM *************************************************************

if not %ip1% =="" (ping %ip1% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname1% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname1% Status: ONLINE >>%iplog%)

if not %ip2% =="" (ping %ip2% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname2% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname2% Status: ONLINE >>%iplog%)

if not %ip3% =="" (ping %ip3% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname3% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname3% Status: ONLINE >>%iplog%)

if not %ip4% =="" (ping %ip4% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname4% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname4% Status: ONLINE >>%iplog%)

if not %ip5% =="" (ping %ip5% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME%% %hostname5% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname5% Status: ONLINE >>%iplog%)

if not %ip6% =="" (ping %ip6% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname6% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname6% Status: ONLINE >>%iplog%)

if not %ip7% =="" (ping %ip7% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname7% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname7% Status: ONLINE >>%iplog%)

if not %ip8% =="" (ping %ip8% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname8% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname8% Status: ONLINE >>%iplog%)

if not %ip9% =="" (ping %ip9% -n 1 -w %iptimeout% |find "TTL=" >>NUL) else (goto END_IPCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %hostname9% Status: OFFLINE >>%iplog%) else (echo %DATE%, %TIME% %hostname9% Status: ONLINE >>%iplog%)

:END_IPCHECK


REM ********************************************************************
REM *Checking for running Programs on Server which shall avoid shutdown*
REM ********************************************************************

if not %rp1% =="" (tasklist |find "%rp1%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp1% Programstatus: STOP >>%pslog%) else (echo %DATE%, %TIME% %rp1% Programstatus: RUN  >>%pslog%)

if not %rp2% =="" (tasklist |find "%rp2%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp2% Programstatus: STOP >>%pslog%) else (echo %DATE%, %TIME% %rp2% Programstatus: RUN  >>%pslog%)

if not %rp3% =="" (tasklist |find "%rp3%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp3% Programstatus: STOP >>%pslog%) else (echo %DATE%, %TIME% %rp3% Programstatus: RUN  >>%pslog%)

if not %rp4% =="" (tasklist |find "%rp4%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp4% Programstatus: STOP >>%pslog%) else (echo %DATE%, %TIME% %rp4% Programstatus: RUN  >>%pslog%)

if not %rp5% =="" (tasklist |find "%rp5%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp5% Programstatus: STOP >>%pslog%) else (echo %DATE%, %TIME% %rp5% Programstatus: RUN  >>%pslog%)

if not %rp6% =="" (tasklist |find "%rp6%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp6% Programstatus: STOP >>%pslog%) else (echo %DATE%, %TIME% %rp6% Programstatus: RUN  >>%pslog%)

if not %rp7% =="" (tasklist |find "%rp7%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp7% Programstatus: STOP >>%pslog%) else (echo %DATE%, %TIME% %rp7% Programstatus: RUN  >>%pslog%)

if not %rp8% =="" (tasklist |find "%rp8%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp8% Programstatus: STOP >>c:%pslog%) else (echo %DATE%, %TIME% %rp8% Programstatus: RUN  >>%pslog%)

if not %rp9% =="" (tasklist |find "%rp9%" >>NUL) else (goto END_PROGCHECK)
if errorlevel 1 (echo %DATE%, %TIME% %rp9% Programstatus: STOP >>c:%pslog%) else (echo %DATE%, %TIME% %rp9% Programstatus: RUN  >>%pslog%)

:END_PROGCHECK


REM ********************************************************************
REM *Checking for running Services on Server which shall avoid shutdown*
REM ********************************************************************

if not %sv1% =="" (net start |find "%sv1%" >>NUL) else (goto END_SERVICECHECK)
if errorlevel 1 (echo %DATE%, %TIME% %sv1% Servicestatus: STOP >>%svlog%) else (echo %DATE%, %TIME% %sv1% Servicestatus: RUN  >>%svlog%)

if not %sv2% =="" (net start |find "%sv2%" >>NUL) else (goto END_SERVICECHECK)
if errorlevel 1 (echo %DATE%, %TIME% %sv2% Servicestatus: STOP >>%svlog%) else (echo %DATE%, %TIME% %sv2% Servicestatus: RUN  >>%svlog%)

if not %sv3% =="" (net start |find "%sv3%" >>NUL) else (goto END_SERVICECHECK)
if errorlevel 1 (echo %DATE%, %TIME% %sv3% Servicestatus: STOP >>%svlog%) else (echo %DATE%, %TIME% %sv3% Servicestatus: RUN  >>%svlog%)


:END_SERVICECHECK


REM ************************************************************
REM *Checking Summary Conditions to shutdown and start Shutdown*
REM ************************************************************

set IP_Result==0 
set PS_Result==0
set SV_Result==0

echo. >> %log%
echo. >> %log%
echo %DATE%, %TIME% LightsOut.XP Conditioncheck started >> %log%
echo. >> %log%

:CHECK_CLIENTS
find "ONLINE" %iplog% >>NUL
if errorlevel 1 (echo Clients  stopped >>%log% && set IP_Result=0) else (echo Clients  run >>%log% && set IP_Result=1)

:CHECK_PROGRAMS
find "RUN" %pslog% >>NUL
if errorlevel 1 (echo Programs stopped >>%log% && set PS_Result=0) else (echo Programs run >>%log% && set PS_Result=1)

:CHECK_SERVICES
find "RUN" %svlog% >>NUL
if errorlevel 1 (echo Services stopped >>%log% && set SV_Result=0) else (echo Services run >>%log% && set PS_Result=1)

:CHECK_LOCALUSER
if exist %wd%\locallyin.use (echo Server locally in use >>%log% && set USE_Result=1) else (echo Server not in use locally >>%log% && set USE_Result=0)
echo %IP_Result% >>killme.txt
echo %PS_Result% >>killme.txt
echo %SV_Result% >>killme.txt
echo %USE_Result% >>killme.txt

if %extendedlog%==on more %iplog% >>LightsOut.XP_Client.log
if %extendedlog%==on more %pslog% >>LightsOut.XP_Program.log
if %extendedlog%==on more %svlog% >>LightsOut.XP_Services.log

del %iplog%
del %pslog%
del %svlog%

find "1" killme.txt >>NUL
echo. >>%log%
if errorlevel 1 (echo .... Server shutdown start in 30 Seconds. >>%log% && goto SERVER_STOP) else (echo ... Server will be in running mode  >>%log% && goto END)


:SERVER_STOP
shutdown -s -t 30
del killme.txt


:END
del killme.txt



